       Subroutine PutNodes(names,icores,nnames,nlen,istart,iend,n0, &
       lout,nl,iu,nu)
!      Encode into the string lout nu nodes starting from location iu
       include 'param.inc'
       integer icores(nmax),nnames,istart(nmax),iend(nmax),nlen(nmax)
       character*20 names(nmax)
       character*80 line
       character*1024 lout
       nl=n0
       nu_in=nu
!
!      Where do we start
       do i=1,nnames
          if(iend(i) .gt. iu )then
                     nstart=i
                     goto 100
          endif
       enddo
!
!      Oops, user has asked for too many nodes
       goto 2000
100    continue

!      How many for this node ?
       ithis=min(nu,iend(nstart)-iu,icores(nstart)) ! iu+1
       lout(nl+1:nl+nlen(nstart))=names(nstart)(1:nlen(nstart))
       nl=nl+nlen(nstart)
       if(ithis.gt.1)then
        if(ithis .lt. 10)then
                write(lout(nl+1:nl+3),110)ithis
110             format(':',i1,' ')
                nl=nl+3
        else
!               Addition for 12 core machines
                write(lout(nl+1:nl+4),111)ithis
111             format(':',i2,' ')
                nl=nl+4
        endif
       else if (nu_in .eq. 1)then
        lout(nl+1:nl+1)=' '
        nl=nl+1
       else
        lout(nl+1:nl+3)=':1 '
        nl=nl+3
       endif
!      Increment number used
       iu=iu+ithis
!      Reduce number we still need
       nu=nu-ithis
!
!      Done ?
       if(nu .le. 0)return
!
!      Go to next node
       nstart=nstart+1
       if(nstart .gt. nnames) goto 2000
!      Loop
       goto 100
!
!      Errors
2000   STOP 'Error: not enough allocated cpu''s'
       end
